<script lang="ts" setup>
import { ref, getCurrentInstance } from 'vue'
import Button from 'primevue/button'
import Column from 'primevue/column'
import DataTable from 'primevue/datatable'
import Dialog from 'primevue/dialog'
import FileUpload, { FileUploadUploadEvent } from 'primevue/fileupload'
import { License } from '@/api/types'
import CheckoutButton from '@/components/CheckoutButton.vue'
import TableSkeleton from '@/components/TableSkeleton.vue'
import { useToast } from 'primevue/usetoast'
import { getErrorMessage } from '@/api/apierror'
import { useLicenseStore } from '@/stores/license'

const component = getCurrentInstance()
const selectedLicenseeId = component?.vnode.key as string ?? ''

const licenseStore = useLicenseStore()

const selectedLicense = ref(null as License | null)
const visible = ref(false)

const loadCheckouts = async () => {
  if (selectedLicenseeId && selectedLicense.value?.id) {
    await licenseStore.getCheckouts(selectedLicenseeId, selectedLicense.value.id)
  }
}

const showCheckouts = async (selected: License) => {
  selectedLicense.value = selected
  if (selected.checkouts.length === 0) {
    await loadCheckouts()
  }
  visible.value = true
}

const releaseUrl = `${import.meta.env.VITE_API_URL}/licenses/release`
const heartbeatUrl = `${import.meta.env.VITE_API_URL}/licenses/heartbeat`

const toast = useToast()

const getHeartbeatResponse = (event: FileUploadUploadEvent) => {
  licenseStore.resetCheckouts()
  if (event.xhr.responseType === "" || event.xhr.responseType === "text") {
    const responseText = event.xhr.response
    const element = document.createElement('a')
    element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(responseText))

    const file: File = Array.isArray(event.files) ? event.files[0] : event.files
    element.setAttribute('download', `updated_${file.name}`)

    element.style.display = 'none'
    document.body.appendChild(element)

    element.click()

    document.body.removeChild(element)
  }

  if (event.xhr.responseType === "json") {
    const error = event.xhr.response
    const errorDetail = getErrorMessage(error)
    toast.add({ severity: 'error', summary: 'An error occurred', detail: errorDetail, life: 5000 })
  }
}

const afterRelease = (event: FileUploadUploadEvent) => {
  licenseStore.resetCheckouts()

  let resultObject
  if (event.xhr.responseType === "json") {
    resultObject = event.xhr.response
  }
  if (event.xhr.responseType === "text" || event.xhr.responseType === "") {
    resultObject = JSON.parse(event.xhr.response)
  }

  if (resultObject.success) {
      toast.add({ severity: 'info', summary: 'License released', detail: 'License released succcessfully', life: 5000 })
      return
  } else {
      const errorDetail = getErrorMessage(resultObject)
      toast.add({ severity: 'error', summary: 'An error occurred', detail: errorDetail, life: 5000 })
      return
  }
}

const loadMoreLicenses = async () => {
  await licenseStore.getMoreLicenses(selectedLicenseeId)
}

await licenseStore.getLicenses(selectedLicenseeId)

</script>

<template>
  <div class="licenses-root">
    <TableSkeleton v-if="licenseStore?.isLoadingLicenses" />
    <div v-if="!licenseStore?.isLoadingLicenses && licenseStore.licenses.length === 0">
      <h2 class="pl-3 text-xl text-left">No licenses available</h2>
    </div>
    <div v-if="!licenseStore?.isLoadingLicenses && licenseStore.licenses.length !== 0">
      <h2 class="pl-4 text-xl text-left">Licenses</h2>
      <DataTable class="pt-3" stripedRows :value="licenseStore.licenses" table-class="min-width: 50rem" data-test="table-licenses">
        <Column field="productName" header="Product" />
        <Column field="validFrom" header="Valid From" />
        <Column field="validTo" header="Valid To" />
        <Column header="Actions">
          <template #body="slotProps">
            <div class="flex flex-row justify-between w-24" :data-test="slotProps.data.id">
              <Button class="bg-themeblue-500 text-slate-50" icon="pi pi-ellipsis-h" size="small"
                aria-label="Show checkouts" @click="showCheckouts(slotProps.data)" data-test="button-show-checkouts" />
              <CheckoutButton :licensee-id="selectedLicenseeId" :id="slotProps.data.id"
                :product-name="slotProps.data.productName" />
            </div>
          </template>
        </Column>
      </DataTable>
      <div class="pt-5" v-if="!licenseStore.allLicensesLoaded">
        <Button @click="loadMoreLicenses" data-test="button-load-more-products">Load more...</Button>
      </div>
      <div class="licenses-global-actions pt-5 flex flex-row justify-center">
        <FileUpload
          id="heartbeat_upload"
          mode="basic"
          auto
          withCredentials
          chooseLabel="Heartbeat"
          :url="heartbeatUrl"
          name="file"
          data-test="heartbeat-upload"
          class="mx-2"
          @upload="getHeartbeatResponse"/>
        <FileUpload
          id="release_upload"
          mode="basic"
          auto
          withCredentials
          chooseLabel="Release"
          :url="releaseUrl"
          name="file"
          data-test="release-upload"
          class="mx-2"
          @upload="afterRelease"/>
      </div>
      <Dialog v-model:visible="visible" modal header="Checkouts" data-test="dialog-checkouts">
        <DataTable :value="selectedLicense?.checkouts" stripedRows
          v-if="!licenseStore.isLoadingCheckouts && selectedLicense?.checkouts !== null && selectedLicense?.checkouts.length !== 0"
          table-class="min-width: 40rem"
          data-test="table-checkouts">
          <Column field="clientHardwareId" header="Hardware ID" />
          <Column field="created" header="Created" />
          <Column field="validFrom" header="Valid From" />
          <Column field="validTo" header="Valid To" />
        </DataTable>
        <div class="pt-5 text-lg" v-if="!licenseStore.isLoadingCheckouts && selectedLicense?.allCheckoutsLoaded">
          All data loaded
        </div>
        <div class="pt-5 flex flex-row justify-between"
          v-if="!licenseStore.isLoadingCheckouts && !selectedLicense?.allCheckoutsLoaded">
          <Button @click="loadCheckouts" data-test="button-load-more-checkouts">Load more data</Button>
        </div>
        <div class="pt-5 text-lg"
          v-if="!licenseStore.isLoadingCheckouts && (selectedLicense?.checkouts === null || selectedLicense?.checkouts.length === 0) && selectedLicense?.allCheckoutsLoaded">
          No current checkouts for this license.
        </div>
        <TableSkeleton v-if="licenseStore.isLoadingCheckouts" />
      </Dialog>
    </div>
  </div>
</template>
